<?xml version="1.0" encoding="UTF-8"?>
<!--This stylesheet generates documentation from a WSDL file-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="/">
        <html>
            <head>
                <style type="text/css"> th { background: #F2EEE4; } td { background: #92B5DF; } </style>
                <title>WSDL Analyzer</title>
            </head>
            <body bgcolor="#D4D0C8">
                <table border="1" align="center" width="100%">
                    <tr>
                        <th colspan="2">
                            <b>
                                <xsl:text>Definitions</xsl:text>
                            </b>
                        </th>
                    </tr>
                    <tr>
                        <th>Name</th>
                        <th>Description</th>
                    </tr>
                    <tr>
                        <td>
                            <xsl:if test="string-length(//*[local-name()='definitions']/@name) = 0">
                                <i> N/A </i>
                            </xsl:if>
                            <i>
                                <xsl:value-of select="//*[local-name()='definitions']/@name"/>
                            </i>
                        </td>
                        <td>
                            <xsl:if test="string-length(//*[local-name()='definitions']/*[local-name()='documentation']) = 0">
                                <i> N/A </i>
                            </xsl:if>
                            <i>
                                <xsl:value-of select="//*[local-name()='definitions']/*[local-name()='documentation']"/>
                            </i>
                        </td>
                    </tr>
                </table>
                <br/>
                <br/>
                <table border="1" align="center" width="100%">
                    <tr>
                        <th colspan="2">
                            <b>
                                <xsl:text>Services</xsl:text>
                            </b>
                        </th>
                    </tr>
                    <tr>
                        <th>Name</th>
                        <th>Description</th>
                    </tr>
                    <xsl:for-each select="//*[local-name()='service']">
                        <tr>
                            <td>
                                <i>
                                    <a>
                                        <xsl:attribute name="href">
                                            <xsl:text>#</xsl:text><xsl:value-of select="@name"/>
                                        </xsl:attribute>
                                        <xsl:value-of select="@name"/>
                                    </a>
                                </i>
                            </td>
                            <td>
                                <xsl:if test="string-length(*[local-name()='documentation']) = 0">
                                    <i> N/A </i>
                                </xsl:if>
                                <i>
                                    <xsl:value-of select="*[local-name()='documentation']"/>
                                </i>
                            </td>
                        </tr>
                    </xsl:for-each>
                </table>
                <br/>
                <br/>
                <xsl:for-each select="//*[local-name()='service']">
                    <table border="1" align="center" width="100%">
                        <tr>
                            <th colspan="3">
                                <b>
                                    <xsl:text>Service : </xsl:text>
                                    <a>
                                        <xsl:attribute name="name">
                                            <xsl:value-of select="@name"/>
                                        </xsl:attribute>
                                        <xsl:value-of select="@name"/>
                                    </a>
                                </b>
                            </th>
                        </tr>
                        <tr>
                            <th>Port</th>
                            <th>Endpoint</th>
                            <th>Description</th>
                        </tr>
                        <xsl:for-each select="*[local-name()='port']">
                            <tr>
                                <td>
                                    <xsl:if test="string-length(@name) = 0">
                                        <i> N/A </i>
                                    </xsl:if>
                                    <i>
                                        <xsl:element name="a">
                                            <xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
                                            <xsl:value-of select="@name"/>
                                        </xsl:element>
                                    </i>
                                </td>
                                <td>
                                    <xsl:if test="string-length(*[local-name()='address']/@location) = 0">
                                        <i> N/A </i>
                                    </xsl:if>
                                    <i>
                                        <a>
                                            <xsl:attribute name="href">
                                                <xsl:value-of select="*[local-name()='address']/@location"/>
                                                <xsl:text>?WSDL</xsl:text>
                                            </xsl:attribute>
                                            <xsl:value-of select="*[local-name()='address']/@location"/>
                                        </a>
                                    </i>
                                </td>
                                <td>
                                    <xsl:if test="string-length(*[local-name()='documentation']) = 0">
                                        <i> N/A </i>
                                    </xsl:if>
                                    <i>
                                        <xsl:value-of select="*[local-name()='documentation']"/>
                                    </i>
                                </td>
                            </tr>
                        </xsl:for-each>
                    </table>
                    <br/>
                    <br/>
                </xsl:for-each>
                <br/>
                <br/>
                <table border="1" align="center" width="100%">
                    <xsl:apply-templates select="//*[local-name()='portType']"/>
                </table>
                <xsl:for-each select="//*[local-name()='portType']/*[local-name()='operation']">
                    <br/>
                    <br/>
                    <table border="1" align="center" width="100%">
                        <tr>
                            <th colspan="4">
                                <xsl:text>Operation : </xsl:text>
                                <a>
                                    <xsl:attribute name="name">
                                        <xsl:value-of select="@name"/>
                                    </xsl:attribute>
                                    <xsl:value-of select="@name"/>
                                </a>
                            </th>
                        </tr>
                        <tr>
                            <td colspan="4" align="center">
                                <i>
                                    <b>Request Parameters</b>
                                </i>
                                <xsl:call-template name="request">
                                    <xsl:with-param name="input" select="./*[local-name()='input']/@message"/>
                                </xsl:call-template>
                            </td>
                            <td colspan="4" align="center">
                                <i>
                                    <b>Response Parameters</b>
                                </i>
                                <xsl:call-template name="response">
                                    <xsl:with-param name="output" select="./*[local-name()='output']/@message"/>
                                </xsl:call-template>
                            </td>
                        </tr>
                    </table>
                </xsl:for-each>
            </body>
        </html>
    </xsl:template>
    <xsl:template match="//*[local-name()='portType']">
        <tr>
            <th colspan="2">
                Operations for Port
                <xsl:element name="a">
                      <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:value-of select="@name"/>
                 </xsl:element>
            </th>
        </tr>
        <tr>
            <th>Name</th>
            <th>Description</th>
        </tr>
        <xsl:for-each select="./*[local-name()='operation']">
            <tr>
                <td>
                    <i>
                        <a>
                            <xsl:attribute name="href">
                                <xsl:text>#</xsl:text><xsl:value-of select="@name"/>
                            </xsl:attribute>
                            <xsl:value-of select="@name"/>
                        </a>
                    </i>
                </td>
                <td>
                    <xsl:if test="string-length(*[local-name()='documentation']) = 0">
                        <i> N/A </i>
                    </xsl:if>
                    <i>
                        <xsl:value-of select="*[local-name()='documentation']"/>
                    </i>
                </td>
            </tr>
        </xsl:for-each>
    </xsl:template>
    <xsl:template name="request">
        <xsl:param name="input"/>
        <tr>
            <th>Name</th>
            <th>Element</th>
            <th>Type</th>
            <th>Description</th>
        </tr>
        <xsl:for-each select="//*[local-name()='message'][contains($input, @name)]/*[local-name()='part']">
            <tr>
                <td>
                    <i>
                        <xsl:value-of select="@name"/>
                    </i>
                </td>
                <td>
                    <xsl:if test="string-length(@element) = 0">
                        <i> N/A </i>
                    </xsl:if>
                    <i>
                        <xsl:value-of select="@element"/>
                    </i>
                </td>
                <td>
                    <xsl:if test="string-length(@type) = 0">
                        <i> N/A </i>
                    </xsl:if>
                    <i>
                        <xsl:value-of select="@type"/>
                    </i>
                </td>
                <td>
                    <xsl:if test="string-length(*[local-name()='documentation']) = 0">
                        <i> N/A </i>
                    </xsl:if>
                    <i>
                        <xsl:value-of select="*[local-name()='documentation']"/>
                    </i>
                </td>
            </tr>
        </xsl:for-each>
    </xsl:template>
    <xsl:template name="response">
        <xsl:param name="output"/>
        <tr>
            <th>Name</th>
            <th>Element</th>
            <th>Type</th>
            <th>Description</th>
        </tr>
        <xsl:for-each select="//*[local-name()='message'][contains($output, @name)]/*[local-name()='part']">
            <tr>
                <td>
                    <i>
                        <xsl:value-of select="@name"/>
                    </i>
                </td>
                <td>
                    <i>
                        <xsl:value-of select="@element"/>
                    </i>
                </td>
                <td>
                    <xsl:if test="string-length(@type) = 0">
                        <i> N/A </i>
                    </xsl:if>
                    <i>
                        <xsl:value-of select="@type"/>
                    </i>
                </td>
                <td>
                    <xsl:if test="string-length(*[local-name()='documentation']) = 0">
                        <i> N/A </i>
                    </xsl:if>
                    <i>
                        <xsl:value-of select="*[local-name()='documentation']"/>
                    </i>
                </td>
            </tr>
        </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>
